/*
**  $Id: grlib4.c,v 1.1 1997/09/30 12:00:00 jochen Rel $
**  Copyright (C) 1997  Jochen Metzinger<1metzing@informatik.uni-hamburg.de>
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Library General Public
**  License as published by the Free Software Foundation; either
**  version 2 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Library General Public License for more details.
**
**  You should have received a copy of the GNU Library General Public
**  License along with this library; if not, write to the Free
**  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
**  MA 02111-1307, USA
*/

#include <vga.h>
#include "vgagl4.h"
#include "driver4.h"


static framebufferfunctions ff4 = {
	driver4_setpixel,
	driver4_getpixel,
	driver4_hline,
	driver4_fillbox,
	driver4_putbox,
	driver4_getbox,
	driver4_putboxmask,
	driver4_putboxpart,
	driver4_getboxpart,
	driver4_copybox
};


static int lockvc = 1;	/* gl_setcontextvga() locks VC */


void
gl4_nolockvc(void)
{
	lockvc = 0;
}


int
gl4_setcontextvga(int m)
{
	if (gl_setcontextvga(m) < 0) {
		return -1;
	}
	if (MODETYPE == CONTEXT_PLANAR16 && WIDTH*HEIGHT <= 640*480) {
		if (lockvc && vga_getcurrentmode() == m) {
			vga_lockvc();
		}
		currentcontext.ff = ff4;
	}
	return 0;
}
